import { Host, h } from "@stencil/core";
import { watchBlockNumber } from "@wagmi/core";
import state from "../../stores/wallet";
import { ethers } from "ethers";
import { convertERC20DecimalsToWei } from "../../utils/erc20";
export class NKDropPriceText {
    constructor() {
        this.price = undefined;
    }
    componentWillLoad() {
        var _a;
        this.disconnect = watchBlockNumber({ listen: true, chainId: (_a = state.chain) === null || _a === void 0 ? void 0 : _a.id }, async () => {
            if (state.diamond.apps.ape) {
                this.price = ethers.utils.formatEther(await state.diamond.apps.ape.apePrice());
                return;
            }
            if (state.diamond.apps.erc20) {
                const erc20PriceInWei = await convertERC20DecimalsToWei(state.publicClient, (await state.diamond.apps.erc20.erc20ActiveCoin()), BigInt(Number(await state.diamond.apps.erc20.erc20Price())));
                this.price = ethers.utils.formatEther(erc20PriceInWei);
                return;
            }
            this.price = ethers.utils.formatEther(await state.diamond.apps.drop.price());
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return (h(Host, null, this.price, h("slot", null)));
    }
    static get is() { return "nk-drop-price-text"; }
    static get encapsulation() { return "shadow"; }
    static get states() {
        return {
            "price": {}
        };
    }
}
//# sourceMappingURL=nk-drop-price-text.js.map
