import { Host, h } from "@stencil/core";
import { watchAccount } from "@wagmi/core";
export class NKIsConnected {
    constructor() {
        this.isConnected = false;
    }
    componentWillLoad() {
        this.disconnect = watchAccount((account) => {
            this.isConnected = account.isConnected;
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return h(Host, null, this.isConnected ? h("slot", null) : null);
    }
    static get is() { return "nk-is-connected"; }
    static get encapsulation() { return "shadow"; }
    static get states() {
        return {
            "isConnected": {}
        };
    }
}
//# sourceMappingURL=nk-is-connected.js.map
