import { Host, h } from "@stencil/core";
import { watchBlockNumber, getAccount } from "@wagmi/core";
import state from "../../stores/wallet";
export class NKIsHolder {
    constructor() {
        this.isHolder = false;
        this.tokenId = undefined;
    }
    componentWillLoad() {
        var _a;
        this.disconnect = watchBlockNumber({ listen: true, chainId: (_a = state.chain) === null || _a === void 0 ? void 0 : _a.id }, async () => {
            const account = getAccount();
            if (this.tokenId) {
                this.isHolder =
                    (await state.diamond.base.ownerOf(this.tokenId)) ===
                        account.address;
            }
            else {
                this.isHolder =
                    Number(await state.diamond.base.balanceOf(account.address)) > 0;
            }
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return h(Host, null, this.isHolder ? h("slot", null) : null);
    }
    static get is() { return "nk-is-holder"; }
    static get encapsulation() { return "shadow"; }
    static get properties() {
        return {
            "tokenId": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Holding a specific Token ID"
                },
                "attribute": "token-id",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "isHolder": {}
        };
    }
}
//# sourceMappingURL=nk-is-holder.js.map
