import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { y as watchBlockNumber } from './chunk-TSH6VVF4.js';
import { s as state } from './wallet.js';
import { c as convertERC20DecimalsToWei } from './erc20.js';
import { f as formatEther } from './index3.js';

const NKDropPriceText = /*@__PURE__*/ proxyCustomElement(class NKDropPriceText extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.price = undefined;
    }
    componentWillLoad() {
        var _a;
        this.disconnect = watchBlockNumber({ listen: true, chainId: (_a = state.chain) === null || _a === void 0 ? void 0 : _a.id }, async () => {
            if (state.diamond.apps.ape) {
                this.price = formatEther(await state.diamond.apps.ape.apePrice());
                return;
            }
            if (state.diamond.apps.erc20) {
                const erc20PriceInWei = await convertERC20DecimalsToWei(state.publicClient, (await state.diamond.apps.erc20.erc20ActiveCoin()), BigInt(Number(await state.diamond.apps.erc20.erc20Price())));
                this.price = formatEther(erc20PriceInWei);
                return;
            }
            this.price = formatEther(await state.diamond.apps.drop.price());
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return (h(Host, null, this.price, h("slot", null)));
    }
}, [1, "nk-drop-price-text", {
        "price": [32]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nk-drop-price-text"];
    components.forEach(tagName => { switch (tagName) {
        case "nk-drop-price-text":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NKDropPriceText);
            }
            break;
    } });
}

const NkDropPriceText = NKDropPriceText;
const defineCustomElement = defineCustomElement$1;

export { NkDropPriceText, defineCustomElement };

//# sourceMappingURL=nk-drop-price-text.js.map