import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { w as watchAccount } from './chunk-TSH6VVF4.js';

const NKIsNotConnected = /*@__PURE__*/ proxyCustomElement(class NKIsNotConnected extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.isNotConnected = true;
    }
    componentWillLoad() {
        this.disconnect = watchAccount((account) => {
            this.isNotConnected = !account.isConnected;
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return h(Host, null, this.isNotConnected ? h("slot", null) : null);
    }
}, [1, "nk-is-not-connected", {
        "isNotConnected": [32]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nk-is-not-connected"];
    components.forEach(tagName => { switch (tagName) {
        case "nk-is-not-connected":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NKIsNotConnected);
            }
            break;
    } });
}

const NkIsNotConnected = NKIsNotConnected;
const defineCustomElement = defineCustomElement$1;

export { NkIsNotConnected, defineCustomElement };

//# sourceMappingURL=nk-is-not-connected.js.map