import { r as registerInstance, h, H as Host } from './index-5ab548a6.js';
import { c as watchBlockNumber } from './chunk-TSH6VVF4-8d7d1859.js';
import { s as state } from './wallet-b8b8ea5e.js';

const NKEditionSupplyText = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.quantity = undefined;
        this.maxQuantity = undefined;
        this.editionId = undefined;
    }
    componentWillLoad() {
        var _a;
        this.disconnect = watchBlockNumber({ listen: true, chainId: (_a = state.chain) === null || _a === void 0 ? void 0 : _a.id }, async () => {
            const edition = await state.diamond.apps.edition.getEdition(this.editionId);
            this.quantity = Number(edition.quantity);
            this.maxQuantity = Number(edition.maxQuantity);
        });
    }
    disconnectedCallback() {
        this.disconnect();
    }
    render() {
        return (h(Host, null, this.maxQuantity === 0
            ? this.quantity
            : `${this.quantity} / ${this.maxQuantity}`, h("slot", null)));
    }
};

export { NKEditionSupplyText as nk_edition_supply_text };

//# sourceMappingURL=nk-edition-supply-text.entry.js.map